Program UFO;

{Twinkling star-field screen saver display, with occasional UFOs flying by.}

const
  MaxStars = 100;
  HideCursor = $2020;
  TwinkleRate = 20;
  UFOinterval = 400;

var
  X, CurrentStar, TotalStars, ChDisplay, OldCursor, UFOTimer, UFOTime: integer;
  UFOX, UFOY, DeltaCount, DeltaX, DeltaY: integer;
  UFO, Ch: char;
  FlyBy: boolean;
  StarField: array [1..MaxStars] of record
                                        StarType: char;
                                        LocX, LocY: integer;
                                      end;


procedure CursorChange (New: integer; VAR Old: integer);
begin
Inline( $31/$C0/$8E/$C0/$26/$A1/$60/$04/$C4/$7E/<OLD/$AB/$B4/$01/$8B/$4E/<NEW
  /$CD/$10 );
end;

procedure Create;
begin
  TotalStars := Random(MaxStars-50)+50;
  for CurrentStar :=1 to TotalStars do
  begin
    with StarField[CurrentStar] do
    begin
      ChDisplay := random(4);       {Set star display character}
      case ChDisplay of
        0: StarType := '.';
        1: StarType := '.';
        2: StarType := '.';
        3: StarType := '*';
      end;
      LocX := random(80)+1;         {Set star X,Y coordinates & brightness}
      LocY := random(25)+1;
    end;
  end;
end;

Function Brightness: integer;
var
  Select: integer;
begin
  Select := random(10);
  Case Select of
    0:  Brightness := 0;
 1..7:  Brightness := 7;
 8..9:  Brightness := 15;
  end;
end;

procedure UFOGo;
begin
  UFOTimer := 0;
  FlyBy := true;
  X := random(5);
  Case X of
    0: UFO := #232;
    1: UFO := #232;
    2: UFO := #15;
    3: UFO := #233;
    4: UFO := #15;
  end;
  X := random(2);
  If X = 0 then
  begin
    UFOX := 0;
    DeltaX := 2;
  end
  else
  begin
    UFOX := 81;
    DeltaX := -2;
  end;
DeltaY := 0;
UFOY := random(24)+1;
end;

procedure SelectNewDirection;
var
  OldDX, OldDY: integer;
begin
{ OldDX := DeltaX;
  OldDY := DeltaY;
  repeat}
    DeltaX := Random(3)-1;
    DeltaY := Random(3)-1;
{ until (ABS(DeltaX)+ABS(DeltaY)<>0);}
  DeltaCount := Random(40)+10;
end;

procedure MoveUFO;
begin
  textColor(0);
  gotoXY(UFOX,UFOY);
  write(UFO);
  DeltaCount := pred(DeltaCount);
  if DeltaCount=0 then SelectNewDirection;
  UFOX := UFOX + DeltaX;
  UFOY := UFOY + DeltaY;
  if (UFOX<1) or (UFOX>80) or (UFOY<1) or (UFOY>25)  then
  begin
    FlyBy := false;
    UFOTimer := 0;
    UFOTime := random(UFOinterval)+UFOinterval;
  end
  else
  begin
    textColor(15);
    gotoXY(UFOX,UFOY);
    write(UFO);
  end;
end;

procedure Display;
begin
  FlyBy := false;
  UFOTime := 100;
  UFOTimer := 0;
  DeltaCount := 50;
  CursorChange(HideCursor,OldCursor);
  CurrentStar := 1;
  repeat
    with StarField[CurrentStar] do
      begin
      textColor(Brightness);
      gotoXY(LocX,LocY);
      write(StarType);
      end;
    Delay(TwinkleRate);
    CurrentStar := Succ(CurrentStar);
    if CurrentStar > TotalStars then CurrentStar := 1;
    UFOTimer := Succ(UFOTimer);
    if UFOTimer = UFOTime then UFOGo;
    if FlyBy and (NOT KeyPressed) then MoveUFO;
  until KeyPressed;
  read(Kbd,Ch);
  CursorChange(OldCursor,OldCursor);
end;

begin
  clrScr;
  Create;
  Display;
  clrScr;
end.
